local chan={}
a,chan[1]=GetChannelName(1)
a,chan[2]=GetChannelName(2)
a,chan[3]=GetChannelName(3)
a,chan[4]=GetChannelName(4)
a,chan[5]=GetChannelName(5)
a,chan[6]=GetChannelName(6)
a,chan[7]=GetChannelName(7)
a,chan[8]=GetChannelName(8)
a,chan[9]=GetChannelName(9)
a,chan[10]=GetChannelName(10)

for i=1, 10 do
 if(chan[i]==nil) then
  chan[i]="-"
 end
end

local minimizeAfterCombat=false

local slashOpts={
 type='group',
 args={
  alpha={
   type='range',
   name='Alpha value of MiniChat button',
   desc='Adjusts transparency of the MiniChat button.',
   usage="(0.0-1.0), 0=invisible, 1=opaque. Note: The button will always be opaque on mouse over.",
   step=0.1,
   get="GetAlpha",
   set="SetAlpha"
  },
  position={
   type='text',
   name='Position',
   desc='Sets the position of the MiniChat button.',
   usage="(topright|bottomright|bottomleft|topleft)",
   get="GetPosition",
   set="SetPosition",
   validate={"topright","bottomright","bottomleft","topleft"}
  },
  within={
   type='toggle',
   name='Show button within the chat window',
   desc='Show the MiniChat button within the chat frame instead of at the corner.',
   get="GetWithin",
   set="SetWithin"
  },
  animationSpeed={
   type='range',
   name='Speed for min-/maximizing (0=no animation)',
   desc='Defines the speed of min-/maximizing the chat window.',
   usage='(0-100)',
   min=0,
   max=100,
   step=1,
   get="GetAnimationSpeed",
   set="SetAnimationSpeed"
  },
  direction={
   type='text',
   name='Direction',
   desc='Defines the direction which MiniChat minimizes to.',
   usage="(up|down)",
   get="GetDirection",
   set="SetDirection",
   validate={"up","down"}
  },
  minimizedLines={
   type='range',
   name='Minimized lines',
   desc='Defines the number of lines shown in minimized state.',
   usage="(1-5)",
   min=1,
   max=5,
   step=1,
   get="GetMinimizedLines",
   set="SetMinimizedLines"
  },
  autoMinimize={
   type='toggle',
   name='Auto minimize',
   desc='Minimizes the chat window automatically.',
   get="GetAutoMinimize",
   set="SetAutoMinimize"
  },
  autoMinimizeAfter={
   type='range',
   name='Auto minimize after',
   desc='Minimizes the chat window after x seconds.',
   usage="(5-600)",
   min=5,
   max=600,
   step=1,
   bigstep=10,
   get="GetAutoMinimizeAfter",
   set="SetAutoMinimizeAfter"
  },
  autoMaximize={
   type='group',
   name='Auto maximize',
   desc='Maximizes the chat window if certain message types are received. This does not ignore messages from muted channels.',
   args={
    enabled={
     type='toggle',
     name='Enabled',
     desc='Enables autoMaximize.',
     get="GetAutoMaximizeEnabled",
     set="SetAutoMaximizeEnabled"
    },
    ignoreSelf={
     type='toggle',
     name='Ignore your messages',
     desc='Don\'t maximize if messages are sent by you.',
     get="GetAutoMaximizeIgnoreSelf",
     set="SetAutoMaximizeIgnoreSelf"
    },
    ignoreIfInCombat={
     type='toggle',
     name='Surpress maximization while in combat.',
     desc='Chat won\'t maximize while in combat but maximization will be scheduled if important events happen during combat.',
     get="GetAutoMaximizeIgnoreIfInCombat",
     set="SetAutoMaximizeIgnoreIfInCombat"
    },
    onYell={
     type='toggle',
     name='on yell',
     desc='Maximizes the chat window when a yell (/y) is received.',
     get="GetAutoMaximizeOnYell",
     set="SetAutoMaximizeOnYell"
    },
    onSay={
     type='toggle',
     name='on say',
     desc='Maximizes the chat window whenever a message (/s) is received.',
     get="GetAutoMaximizeOnSay",
     set="SetAutoMaximizeOnSay"
    },
    onWhisper={
     type='toggle',
     name='on whisper',
     desc='Maximizes the chat window whenever a whisper (/w) is received.',
     get="GetAutoMaximizeOnWhisper",
     set="SetAutoMaximizeOnWhisper"
    },
    onGuild={
     type='toggle',
     name='on guild',
     desc='Maximizes the chat window whenever a guild message (/g) is received.',
     get="GetAutoMaximizeOnGuild",
     set="SetAutoMaximizeOnGuild"
    },
    onParty={
     type='toggle',
     name='on party',
     desc='Maximizes the chat window whenever a party message (/p) is received.',
     get="GetAutoMaximizeOnParty",
     set="SetAutoMaximizeOnParty"
    },
    onRaid={
     type='toggle',
     name='on raid',
     desc='Maximizes the chat window whenever a raid message (/ra) is received.',
     get="GetAutoMaximizeOnRaid",
     set="SetAutoMaximizeOnRaid"
    },
    onBattleground={
     type='toggle',
     name='on battleground',
     desc='Maximizes the chat window whenever a battleground message (/bg or battleground system message) is received.',
     get="GetAutoMaximizeOnBattleground",
     set="SetAutoMaximizeOnBattleground"
    },
    onOfficer={
     type='toggle',
     name='on officer',
     desc='Maximizes the chat window whenever an officer message (/o) is received.',
     get="GetAutoMaximizeOnOfficer",
     set="SetAutoMaximizeOnOfficer"
    },
    onChannel={
     type='group',
     name='on channel',
     desc='Maximizes the chat window whenever a message is received in custom channels.',
     args={
      channel1={
       type='toggle',
       name='01: '..tostring(chan[1]),
       desc='Enables autoMaximize for '..tostring(chan[1]),
       get="GetAutoMaximizeOnChannel1",
       set="SetAutoMaximizeOnChannel1"
      },
      channel2={
       type='toggle',
       name='02: '..tostring(chan[2]),
       desc='Enables autoMaximize for '..tostring(chan[2]),
       get="GetAutoMaximizeOnChannel2",
       set="SetAutoMaximizeOnChannel2"
      },
      channel3={
       type='toggle',
       name='03: '..tostring(chan[3]),
       desc='Enables autoMaximize for '..tostring(chan[3]),
       get="GetAutoMaximizeOnChannel3",
       set="SetAutoMaximizeOnChannel3"
      },
      channel4={
       type='toggle',
       name='04: '..tostring(chan[4]),
       desc='Enables autoMaximize for '..tostring(chan[4]),
       get="GetAutoMaximizeOnChannel4",
       set="SetAutoMaximizeOnChannel4"
      },
      channel5={
       type='toggle',
       name='05: '..tostring(chan[5]),
       desc='Enables autoMaximize for '..tostring(chan[5]),
       get="GetAutoMaximizeOnChannel5",
       set="SetAutoMaximizeOnChannel5"
      },
      channel6={
       type='toggle',
       name='06: '..tostring(chan[6]),
       desc='Enables autoMaximize for '..tostring(chan[6]),
       get="GetAutoMaximizeOnChannel6",
       set="SetAutoMaximizeOnChannel6"
      },
      channel7={
       type='toggle',
       name='07: '..tostring(chan[7]),
       desc='Enables autoMaximize for '..tostring(chan[7]),
       get="GetAutoMaximizeOnChannel7",
       set="SetAutoMaximizeOnChannel7"
      },
      channel8={
       type='toggle',
       name='08: '..tostring(chan[8]),
       desc='Enables autoMaximize for '..tostring(chan[8]),
       get="GetAutoMaximizeOnChannel8",
       set="SetAutoMaximizeOnChannel8"
      },
      channel9={
       type='toggle',
       name='09: '..tostring(chan[9]),
       desc='Enables autoMaximize for '..tostring(chan[9]),
       get="GetAutoMaximizeOnChannel9",
       set="SetAutoMaximizeOnChannel9"
      },
      channel10={
       type='toggle',
       name='10: '..tostring(chan[10]),
       desc='Enables autoMaximize for '..tostring(chan[10]),
       get="GetAutoMaximizeOnChannel10",
       set="SetAutoMaximizeOnChannel10"
      }
     }
    }
   }
  },
  gui={
   type='execute',
   guiHidden=true,
   name='GUI',
   desc='Opens config GUI.',
   func=function()
    waterfall:Open('MiniChat GUI')
   end
  }
 }
}

MiniChat=AceLibrary("AceAddon-2.0"):new("AceConsole-2.0","AceEvent-2.0","AceDB-2.0")
MiniChat:RegisterChatCommand("/mc","/minichat",slashOpts)
MiniChat:RegisterDB("MiniChatDB")
MiniChat:RegisterDefaults("profile",{
 ChatHeight=0,
 ChatLeft=0,
 ChatBottom=0,
 FontHeight=12,
 Minimized=false,
 Alpha=1,
 Position="topright",
 Within=false,
 AnimationSpeed=0,
 Direction="down",
 MinimizedLines=1,
 AutoMinimize=false,
 AutoMinimizeAfter=60,
 AutoMaximizeEnabled=false,
 AutoMaximizeIgnoreIfInCombat=false,
 AutoMaximizeIgnoreSelf=false,
 AutoMaximizeOnYell=false,
 AutoMaximizeOnSay=false,
 AutoMaximizeOnWhisper=false,
 AutoMaximizeOnGuild=false,
 AutoMaximizeOnParty=false,
 AutoMaximizeOnRaid=false,
 AutoMaximizeOnBattleground=false,
 AutoMaximizeOnOfficer=false,
 AutoMaximizeOnChannel={}
})
waterfall=AceLibrary("Waterfall-1.0")
waterfall:Register('MiniChat GUI','aceOptions',slashOpts,'title')


local MiniB=CreateFrame("Button",nil,UIParent)

function MiniChat:OnDisable()
 MiniB:Hide()
 self:Unhook("ChatFrame_MessageEventHandler")
end

function MiniChat:OnEnable()
 MiniB:SetFrameStrata("Low")
 MiniB:SetWidth(25)
 MiniB:SetHeight(25)
 MiniB:SetAlpha(self.db.profile.Alpha)

 local MiniBTexture = MiniB:CreateTexture(nil,"BACKGROUND")
 MiniBTexture:SetTexture("Interface\\Glues\\CharacterCreate\\UI-RotationRight-Big-Up.blp")
 MiniBTexture:SetAllPoints(MiniB)
 MiniB.texture = MiniBTexture

 self:RegisterEvent("MINICHAT_SMOOTHING")
 self:RegisterEvent("MINICHAT_AUTOMINIMIZE")
 self:RegisterEvent("CHAT_MSG_CHANNEL")
 self:RegisterEvent("CHAT_MSG_OFFICER")
 self:RegisterEvent("CHAT_MSG_BG_SYSTEM_ALLIANCE")
 self:RegisterEvent("CHAT_MSG_BG_SYSTEM_HORDE")
 self:RegisterEvent("CHAT_MSG_BG_SYSTEM_NEUTRAL")
 self:RegisterEvent("CHAT_MSG_BATTLEGROUND")
 self:RegisterEvent("CHAT_MSG_BATTLEGROUND_LEADER")
 self:RegisterEvent("UPDATE_WORLD_STATES")
 self:RegisterEvent("CHAT_MSG_PARTY")
 self:RegisterEvent("CHAT_MSG_RAID")
 self:RegisterEvent("CHAT_MSG_RAID_LEADER")
 self:RegisterEvent("CHAT_MSG_GUILD")
 self:RegisterEvent("CHAT_MSG_SAY")
 self:RegisterEvent("CHAT_MSG_WHISPER")
 self:RegisterEvent("CHAT_MSG_WHISPER_INFORM")
 self:RegisterEvent("CHAT_MSG_YELL")
 self:RegisterEvent("PLAYER_REGEN_ENABLED")

 if(self.db.profile.AutoMinimize and not self.db.profile.Minimized) then
  self:MiniMax()
 end
 
 if(self.db.profile.Within) then
  MiniB:SetPoint(self.db.profile.Position,DEFAULT_CHAT_FRAME,self.db.profile.Position,0,0)
 else
  MiniB:SetPoint("CENTER",DEFAULT_CHAT_FRAME,self.db.profile.Position,0,0)
 end
 MiniB:Show()

 -- MouseDown on button
 MiniB:SetScript("OnMouseDown",function()
  MiniBTexture:SetTexture("Interface\\Glues\\CharacterCreate\\UI-RotationRight-Big-Down.blp")
 end)
  -- MouseUp on button
 MiniB:SetScript("OnMouseUp",function()
  MiniBTexture:SetTexture("Interface\\Glues\\CharacterCreate\\UI-RotationRight-Big-Up.blp")
 end)

 -- Button clicked
 MiniB:SetScript("OnClick",function()
  self.db.profile.ChatLeft=DEFAULT_CHAT_FRAME:GetLeft()
  self.db.profile.ChatBottom=DEFAULT_CHAT_FRAME:GetBottom()
  a,self.db.profile.FontHeight,a=DEFAULT_CHAT_FRAME:GetFont()
  local expand
  self:MiniMax()
 end)
 
 -- Mouse leaves button 
 MiniB:SetScript("OnLeave",function()
  MiniB:SetAlpha(self.db.profile.Alpha)
 end)
  -- Mouse is moved over button
 MiniB:SetScript("OnEnter",function()
  MiniB:SetAlpha(1)
 end)
end

function MiniChat:GetAlpha()
 return self.db.profile.Alpha
end
function MiniChat:SetAlpha(newAlpha)
 self.db.profile.Alpha=newAlpha
 MiniB:SetAlpha(newAlpha)
end


function MiniChat:GetPosition()
 return self.db.profile.Position
end
function MiniChat:SetPosition(newPosition)
 MiniB:ClearAllPoints()
 self.db.profile.Position=newPosition
 if(self.db.profile.Within) then
  MiniB:SetPoint(newPosition,DEFAULT_CHAT_FRAME,newPosition,0,0)
 else
  MiniB:SetPoint("CENTER",DEFAULT_CHAT_FRAME,newPosition,0,0)
 end
end


function MiniChat:GetWithin()
 return self.db.profile.Within
end
function MiniChat:SetWithin(newWithin)
 MiniB:ClearAllPoints()
 self.db.profile.Within=newWithin
 if(newWithin) then
  MiniB:SetPoint(self.db.profile.Position,DEFAULT_CHAT_FRAME,self.db.profile.Position,0,0)
 else
  MiniB:SetPoint("CENTER",DEFAULT_CHAT_FRAME,self.db.profile.Position,0,0)
 end
end


function MiniChat:GetAnimationSpeed()
 return self.db.profile.AnimationSpeed
end
function MiniChat:SetAnimationSpeed(newAnimationSpeed)
 self.db.profile.AnimationSpeed=newAnimationSpeed
end


function MiniChat:GetDirection()
 return self.db.profile.Direction
end
function MiniChat:SetDirection(newDirection)
 self.db.profile.Direction=newDirection
 DEFAULT_CHAT_FRAME:ClearAllPoints()
 if(newDirection=="up") then
  DEFAULT_CHAT_FRAME:SetPoint("TOPLEFT",UIParent,"BOTTOMLEFT",DEFAULT_CHAT_FRAME:GetLeft(),DEFAULT_CHAT_FRAME:GetTop())
 else
  DEFAULT_CHAT_FRAME:SetPoint("BOTTOMLEFT",UIParent,"BOTTOMLEFT",DEFAULT_CHAT_FRAME:GetLeft(),DEFAULT_CHAT_FRAME:GetBottom())
 end
end


function MiniChat:GetMinimizedLines()
 return self.db.profile.MinimizedLines
end
function MiniChat:SetMinimizedLines(newMinimizedLines)
 self.db.profile.MinimizedLines=newMinimizedLines
end

function MiniChat:GetAutoMinimize()
 return self.db.profile.AutoMinimize
end
function MiniChat:SetAutoMinimize(newAutoMinimize)
 self.db.profile.AutoMinimize=newAutoMinimize
end
function MiniChat:GetAutoMinimizeAfter()
 return self.db.profile.AutoMinimizeAfter
end
function MiniChat:SetAutoMinimizeAfter(newAutoMinimizeAfter)
 self.db.profile.AutoMinimizeAfter=newAutoMinimizeAfter
end

function MiniChat:GetAutoMaximizeEnabled()
 return self.db.profile.AutoMaximizeEnabled
end
function MiniChat:SetAutoMaximizeEnabled(newAutoMaximizeEnabled)
 self.db.profile.AutoMaximizeEnabled=newAutoMaximizeEnabled
end

function MiniChat:GetAutoMaximizeIgnoreIfInCombat()
 return self.db.profile.AutoMaximizeIgnoreIfInCombat
end
function MiniChat:SetAutoMaximizeIgnoreIfInCombat(newAutoMaximizeIgnoreIfInCombat)
 self.db.profile.AutoMaximizeIgnoreIfInCombat=newAutoMaximizeIgnoreIfInCombat
end
function MiniChat:GetAutoMaximizeIgnoreSelf()
 return self.db.profile.AutoMaximizeIgnoreSelf
end
function MiniChat:SetAutoMaximizeIgnoreSelf(newAutoMaximizeIgnoreSelf)
 self.db.profile.AutoMaximizeIgnoreSelf=newAutoMaximizeIgnoreSelf
end
function MiniChat:GetAutoMaximizeOnYell()
 return self.db.profile.AutoMaximizeOnYell
end
function MiniChat:SetAutoMaximizeOnYell(newAutoMaximizeOnYell)
 self.db.profile.AutoMaximizeOnYell=newAutoMaximizeOnYell
end
function MiniChat:GetAutoMaximizeOnSay()
 return self.db.profile.AutoMaximizeOnSay
end
function MiniChat:SetAutoMaximizeOnSay(newAutoMaximizeOnSay)
 self.db.profile.AutoMaximizeOnSay=newAutoMaximizeOnSay
end
function MiniChat:GetAutoMaximizeOnWhisper()
 return self.db.profile.AutoMaximizeOnWhisper
end
function MiniChat:SetAutoMaximizeOnWhisper(newAutoMaximizeOnWhisper)
 self.db.profile.AutoMaximizeOnWhisper=newAutoMaximizeOnWhisper
end
function MiniChat:GetAutoMaximizeOnGuild()
 return self.db.profile.AutoMaximizeOnGuild
end
function MiniChat:SetAutoMaximizeOnGuild(newAutoMaximizeOnGuild)
 self.db.profile.AutoMaximizeOnGuild=newAutoMaximizeOnGuild
end
function MiniChat:GetAutoMaximizeOnParty()
 return self.db.profile.AutoMaximizeOnParty
end
function MiniChat:SetAutoMaximizeOnParty(newAutoMaximizeOnParty)
 self.db.profile.AutoMaximizeOnParty=newAutoMaximizeOnParty
end
function MiniChat:GetAutoMaximizeOnRaid()
 return self.db.profile.AutoMaximizeOnRaid
end
function MiniChat:SetAutoMaximizeOnRaid(newAutoMaximizeOnRaid)
 self.db.profile.AutoMaximizeOnRaid=newAutoMaximizeOnRaid
end
function MiniChat:GetAutoMaximizeOnBattleground()
 return self.db.profile.AutoMaximizeOnBattleground
end
function MiniChat:SetAutoMaximizeOnBattleground(newAutoMaximizeOnBattleground)
 self.db.profile.AutoMaximizeOnBattleground=newAutoMaximizeOnBattleground
end
function MiniChat:GetAutoMaximizeOnOfficer()
 return self.db.profile.AutoMaximizeOnOfficer
end
function MiniChat:SetAutoMaximizeOnOfficer(newAutoMaximizeOnOfficer)
 self.db.profile.AutoMaximizeOnOfficer=newAutoMaximizeOnOfficer
end
function MiniChat:GetAutoMaximizeOnChannel1()
 return self.db.profile.AutoMaximizeOnChannel[1]
end
function MiniChat:SetAutoMaximizeOnChannel1(newAutoMaximizeOnChannel1)
 self.db.profile.AutoMaximizeOnChannel[1]=newAutoMaximizeOnChannel1
end
function MiniChat:GetAutoMaximizeOnChannel2()
 return self.db.profile.AutoMaximizeOnChannel[2]
end
function MiniChat:SetAutoMaximizeOnChannel2(newAutoMaximizeOnChannel2)
 self.db.profile.AutoMaximizeOnChannel[2]=newAutoMaximizeOnChannel2
end
function MiniChat:GetAutoMaximizeOnChannel3()
 return self.db.profile.AutoMaximizeOnChannel[3]
end
function MiniChat:SetAutoMaximizeOnChannel3(newAutoMaximizeOnChannel3)
 self.db.profile.AutoMaximizeOnChannel[3]=newAutoMaximizeOnChannel3
end
function MiniChat:GetAutoMaximizeOnChannel4()
 return self.db.profile.AutoMaximizeOnChannel[4]
end
function MiniChat:SetAutoMaximizeOnChannel4(newAutoMaximizeOnChannel4)
 self.db.profile.AutoMaximizeOnChannel[4]=newAutoMaximizeOnChannel4
end
function MiniChat:GetAutoMaximizeOnChannel5()
 return self.db.profile.AutoMaximizeOnChannel[5]
end
function MiniChat:SetAutoMaximizeOnChannel5(newAutoMaximizeOnChannel5)
 self.db.profile.AutoMaximizeOnChannel[5]=newAutoMaximizeOnChannel5
end
function MiniChat:GetAutoMaximizeOnChannel6()
 return self.db.profile.AutoMaximizeOnChannel[6]
end
function MiniChat:SetAutoMaximizeOnChannel6(newAutoMaximizeOnChannel6)
 self.db.profile.AutoMaximizeOnChannel[6]=newAutoMaximizeOnChannel6
end
function MiniChat:GetAutoMaximizeOnChannel7()
 return self.db.profile.AutoMaximizeOnChannel[7]
end
function MiniChat:SetAutoMaximizeOnChannel7(newAutoMaximizeOnChannel7)
 self.db.profile.AutoMaximizeOnChannel[7]=newAutoMaximizeOnChannel7
end
function MiniChat:GetAutoMaximizeOnChannel8()
 return self.db.profile.AutoMaximizeOnChannel[8]
end
function MiniChat:SetAutoMaximizeOnChannel8(newAutoMaximizeOnChannel8)
 self.db.profile.AutoMaximizeOnChannel[8]=newAutoMaximizeOnChannel8
end
function MiniChat:GetAutoMaximizeOnChannel9()
 return self.db.profile.AutoMaximizeOnChannel[9]
end
function MiniChat:SetAutoMaximizeOnChannel9(newAutoMaximizeOnChannel9)
 self.db.profile.AutoMaximizeOnChannel[9]=newAutoMaximizeOnChannel9
end
function MiniChat:GetAutoMaximizeOnChannel10()
 return self.db.profile.AutoMaximizeOnChannel[10]
end
function MiniChat:SetAutoMaximizeOnChannel10(newAutoMaximizeOnChannel10)
 self.db.profile.AutoMaximizeOnChannel[10]=newAutoMaximizeOnChannel10
end


function MiniChat:MiniMax()
 self.db.profile.ChatLeft=DEFAULT_CHAT_FRAME:GetLeft()
 self.db.profile.ChatBottom=DEFAULT_CHAT_FRAME:GetBottom()
 if(not self.db.profile.Minimized) then -- maximized
  self.db.profile.ChatHeight=DEFAULT_CHAT_FRAME:GetHeight()
  expand=false
  if(self.db.profile.AnimationSpeed==0) then
   DEFAULT_CHAT_FRAME:SetHeight((self.db.profile.MinimizedLines+0.1)*self.db.profile.FontHeight)
  end
  if(self.db.profile.Direction=="down") then
   DEFAULT_CHAT_FRAME:ClearAllPoints()
   DEFAULT_CHAT_FRAME:SetPoint("BOTTOMLEFT",UIParent,"BOTTOMLEFT",self.db.profile.ChatLeft,self.db.profile.ChatBottom)
  end
 self.db.profile.Minimized=true
 self:CancelAllScheduledEvents()
 else -- minimized
  expand=true
  if(self.db.profile.AnimationSpeed==0) then
   DEFAULT_CHAT_FRAME:SetHeight(self.db.profile.ChatHeight)
  end
  if(self.db.profile.Direction=="down") then   
   DEFAULT_CHAT_FRAME:ClearAllPoints()
   DEFAULT_CHAT_FRAME:SetPoint("BOTTOMLEFT",UIParent,"BOTTOMLEFT",self.db.profile.ChatLeft,self.db.profile.ChatBottom)
  end
  self.db.profile.Minimized=false
  if(self.db.profile.AutoMinimize) then
   self:ScheduleEvent("minichatautominimize","MINICHAT_AUTOMINIMIZE",self.db.profile.AutoMinimizeAfter)
  end
 end
 if(self.db.profile.AnimationSpeed>0) then
  MiniB:Hide()
  self:ScheduleEvent("minichatsmoothing","MINICHAT_SMOOTHING",0.025,expand)
 else
  DEFAULT_CHAT_FRAME:ScrollDown()
 end
end

function MiniChat:PLAYER_REGEN_ENABLED()
 if(maximizeAfterCombat) then
  maximizeAfterCombat=false
  if(self.db.profile.Minimized) then
   self:MiniMax()
  end
 end
end

function MiniChat:CHAT_MSG_CHANNEL(a,author,a,a,a,a,a,nr)
 if(self.db.profile.AutoMaximizeIgnoreSelf and author==UnitName("player")) then
  return
 end
 self:CatchMessage(self.db.profile.AutoMaximizeOnChannel[nr])
end
function MiniChat:CHAT_MSG_YELL(a,author)
 if(self.db.profile.AutoMaximizeIgnoreSelf and author==UnitName("player")) then
  return
 end
 self:CatchMessage(self.db.profile.AutoMaximizeOnYell)
end
function MiniChat:CHAT_MSG_SAY(a,author)
 if(self.db.profile.AutoMaximizeIgnoreSelf and author==UnitName("player")) then
  return
 end
 self:CatchMessage(self.db.profile.AutoMaximizeOnSay)
end
function MiniChat:CHAT_MSG_WHISPER(a,author)
 if(self.db.profile.AutoMaximizeIgnoreSelf and author==UnitName("player")) then
  return
 end
 self:CatchMessage(self.db.profile.AutoMaximizeOnWhisper)
end
function MiniChat:CHAT_MSG_WHISPER_INFORM()
 if(self.db.profile.AutoMaximizeIgnoreSelf) then
  return
 end
 self:CatchMessage(self.db.profile.AutoMaximizeOnWhisper)
end
function MiniChat:CHAT_MSG_GUILD(a,author)
 if(self.db.profile.AutoMaximizeIgnoreSelf and author==UnitName("player")) then
  return
 end
 self:CatchMessage(self.db.profile.AutoMaximizeOnGuild)
end
function MiniChat:CHAT_MSG_PARTY(a,author)
 if(self.db.profile.AutoMaximizeIgnoreSelf and author==UnitName("player")) then
  return
 end
 self:CatchMessage(self.db.profile.AutoMaximizeOnParty)
end
function MiniChat:CHAT_MSG_RAID(a,author)
 if(self.db.profile.AutoMaximizeIgnoreSelf and author==UnitName("player")) then
  return
 end
 self:CatchMessage(self.db.profile.AutoMaximizeOnRaid)
end
function MiniChat:CHAT_MSG_RAID_LEADER(a,author)
 if(self.db.profile.AutoMaximizeIgnoreSelf and author==UnitName("player")) then
  return
 end
 self:CatchMessage(self.db.profile.AutoMaximizeOnRaid)
end
function MiniChat:CHAT_MSG_BATTLEGROUND(a,author)
 if(self.db.profile.AutoMaximizeIgnoreSelf and author==UnitName("player")) then
  return
 end
 self:CatchMessage(self.db.profile.AutoMaximizeOnBattleground)
end
function MiniChat:CHAT_MSG_BATTLEGROUND_LEADER(a,author)
 if(self.db.profile.AutoMaximizeIgnoreSelf and author==UnitName("player")) then
  return
 end
 self:CatchMessage(self.db.profile.AutoMaximizeOnBattleground)
end
function MiniChat:CHAT_MSG_BG_SYSTEM_ALLIANCE()
 self:CatchMessage(self.db.profile.AutoMaximizeOnBattleground)
end
function MiniChat:CHAT_MSG_BG_SYSTEM_HORDE()
 self:CatchMessage(self.db.profile.AutoMaximizeOnBattleground)
end
function MiniChat:CHAT_MSG_BG_SYSTEM_NEUTRAL()
 self:CatchMessage(self.db.profile.AutoMaximizeOnBattleground)
end
function MiniChat:UPDATE_WORLD_STATES()
 self:CatchMessage(self.db.profile.AutoMaximizeOnBattleground)
end
function MiniChat:CHAT_MSG_OFFICER(a,author)
 if(self.db.profile.AutoMaximizeIgnoreSelf and author==UnitName("player")) then
  return
 end
 self:CatchMessage(self.db.profile.AutoMaximizeOnOfficer)
end
function MiniChat:CatchMessage(msgtypeenabled)
 if(self.db.profile.AutoMaximizeEnabled and msgtypeenabled) then
  if(self.db.profile.AutoMaximizeIgnoreIfInCombat and UnitAffectingCombat("player")) then
   maximizeAfterCombat=true
   return
  end
  if(self.db.profile.AutoMinimize) then
    if(self:IsEventScheduled("minichatautominimize")) then
     self:CancelScheduledEvent("minichatautominimize")
    end
    self:ScheduleEvent("minichatautominimize","MINICHAT_AUTOMINIMIZE",self.db.profile.AutoMinimizeAfter)
  end
  if(self.db.profile.Minimized) then
   self:MiniMax()
  end
 end
end

function MiniChat:MINICHAT_AUTOMINIMIZE()
 if(not self.db.profile.Minimized) then
  self:MiniMax()
 end
end

function MiniChat:MINICHAT_SMOOTHING(expand)
 local lower=floor((self.db.profile.MinimizedLines+0.1)*self.db.profile.FontHeight)
 if(expand) then
  DEFAULT_CHAT_FRAME:SetHeight(math.floor(DEFAULT_CHAT_FRAME:GetHeight()+2+self.db.profile.AnimationSpeed*DEFAULT_CHAT_FRAME:GetHeight()/120))
  if(DEFAULT_CHAT_FRAME:GetHeight()>self.db.profile.ChatHeight) then
   DEFAULT_CHAT_FRAME:SetHeight(self.db.profile.ChatHeight)
  end
 else
  DEFAULT_CHAT_FRAME:SetHeight(math.ceil(DEFAULT_CHAT_FRAME:GetHeight()-2-self.db.profile.AnimationSpeed*DEFAULT_CHAT_FRAME:GetHeight()/120))
  if(DEFAULT_CHAT_FRAME:GetHeight()<lower) then
   DEFAULT_CHAT_FRAME:SetHeight(lower)
  end
 end
 if(self.db.profile.Direction=="down") then
  DEFAULT_CHAT_FRAME:ClearAllPoints()
  DEFAULT_CHAT_FRAME:SetPoint("BOTTOMLEFT",UIParent,"BOTTOMLEFT",self.db.profile.ChatLeft,self.db.profile.ChatBottom)
 end
 if((DEFAULT_CHAT_FRAME:GetHeight()>lower and not expand)
    or
    (DEFAULT_CHAT_FRAME:GetHeight()<self.db.profile.ChatHeight and expand)) then
  self:ScheduleEvent("minichatsmoothing","MINICHAT_SMOOTHING",0.025,expand)
 else
  DEFAULT_CHAT_FRAME:ScrollDown()
  MiniB:Show()
 end
end